import com.sun.corba.se.impl.transport.ListenerThreadImpl;
import com.sun.org.apache.bcel.internal.generic.ARRAYLENGTH;
import java.awt.Component;
import java.awt.Image;
import java.awt.List;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.AreaAveragingScaleFilter;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageFilter;
import java.awt.image.ImageProducer;
import java.awt.image.PixelGrabber;
import java.awt.image.WritableRaster;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;


/*
 * GepGoogleImgViewer.java
 *
 * Created on 2008/02/06, 21:18
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author jinpu
 */
public class GepGoogleImgViewer {
    
//20080416 f@\ǉ start
    private GoogleSearchImgExec imginfo;
//20080416 f@\ǉ end
    private GoogleSearchExec searchmain;
    private String _keyword;
    private ArrayList ImgFileList;
//20080411 摜do^h~ start
    private HashSet PreemptedURLSet;
//20080411 摜do^h~ end
//20080419 [JLbVΉ start
    private HashSet PreemptedFilePathSet;
//20080419 [JLbVΉ end
    private int DLImgDataSie;
    private int DLImgHight;
    private int DLImgWidth;
    private byte[] ImgdataBuf;
    private byte[] ThumbBuf;
    static protected HashMap extcnvhash;
    static protected HashMap extcnvhashsm;
    public static final String rootdir = "dlimg";
    public static final String filemdir = "main";
    private File RootDir;
    private boolean IsExec;
    private javax.swing.JButton _firstbutton;    /** Creates a new instance of FirstSearchThread */
    private javax.swing.JButton _nextbutton;    /** Creates a new instance of FirstSearchThread */
    private javax.swing.JButton _prevbutton;    /** Creates a new instance of FirstSearchThread */
            
//20080415 f@\ǉ start
    private javax.swing.JLabel infolabel;
//20080415 f@\ǉ end
    private static final int ThumbHight = 120;
    private static final int ThumbWidth = 120;
//20080418 [JLbVΉ start
    private boolean StopExecLocal;
//20080418 [JLbVΉ end
//20080419 [JLbVΉ start
    public static final int SearchMode_Web   = 1;
    public static final int SearchMode_Local = 2;
    private int SearchMode;
    private GepGoogleImgViewerForm _form;
//20080419 [JLbVΉ end       

//20080724 摜 start
    private int ExecThreadCnt;
    private int _ResultPageCnt;
//20080914 C҂Ή start
    private int _InnerPageCnt;
//20081214 ςURLXLbvΉ start
    public HashSet<String> AlreadySearchURLs;
//20081214 ςURLXLbvΉ end
    
    public int getInnerPageCnt()
    {
        return _InnerPageCnt;
    }
    
    public void incInnerPageCnt()
    {
        _InnerPageCnt++;
    }
    
    public void clearInnerPageCnt()
    {
        _InnerPageCnt = 0;
    }
//20080914 C҂Ή end
    public int getResultPageCnt()
    {
        return _ResultPageCnt;
    }
    
    public int getExecThreadCnt()
    {
        return ExecThreadCnt;
    }
    
    public synchronized void incExecThreadCnt()
    {
        ExecThreadCnt++;
    }
    public synchronized void clearExecThreadCnt()
    {
        ExecThreadCnt = 0;
    }
    
    public synchronized void decExecThreadCnt()
    {
        ExecThreadCnt--;
        if ( ExecThreadCnt < 0 ) {
            ExecThreadCnt = 0;
        }
    }
    
    private boolean StopExec; 

    public void setStopExecMain(boolean flag)
    {
        StopExec = flag;
    }

    public boolean getStopExecMain()
    {
        return StopExec;
    }
    
    public File getRootDir()
    {
        return RootDir;
    }
//20080724 摜 end
    
    /** Creates a new instance of GepGoogleImgViewer */
//20080419 [JLbVΉ start
//    public GepGoogleImgViewer() {
    public GepGoogleImgViewer(GepGoogleImgViewerForm form) {
        this._form = form;
//20080419 [JLbVΉ end
        searchmain = new GoogleSearchExec(); 
        DLImgHight = 0;
        DLImgWidth = 0;
        DLImgDataSie = 0;
        IsExec       = false;
        ImgdataBuf = new byte[4096];
        extcnvhash = new HashMap();
        extcnvhash.put("jpeg", "jpg");
        extcnvhashsm = new HashMap();
        extcnvhashsm.put("jpg", "jpeg");
        ImgFileList = new ArrayList();
//20080411 摜do^h~ start
        PreemptedURLSet = new HashSet();
//20080411 摜do^h~ end
//20080418 [JLbVΉ start
        StopExecLocal = false;
//20080418 [JLbVΉ end
//20080419 [JLbVΉ start
        PreemptedFilePathSet = new HashSet();
        SearchMode = GepGoogleImgViewer.SearchMode_Web;
//20080419 [JLbVΉ end       
//20080724 摜 start
        ExecThreadCnt = 0;
//20080724 摜 end
//20080914 C҂Ή start
        _InnerPageCnt = 0;
//20080914 C҂Ή end
//20081214 ςURLXLbvΉ start
        AlreadySearchURLs = new HashSet<String>();
//20081214 ςURLXLbvΉ end
    }
//20080419 [JLbVΉ start
    public int getSearchMode()
    {
        return SearchMode;
    }

    public void setSearchMode(int mode)
    {
        switch ( mode ) {
            case GepGoogleImgViewer.SearchMode_Web :
            case GepGoogleImgViewer.SearchMode_Local :
                SearchMode = mode;
                break;
            default :
            System.out.println("sȃ[hw肳܂Bmode = " + mode);
        }
    }
//20080419 [JLbVΉ end       
//20080418 [JLbVΉ start
    public void setStopExecLocal(boolean flag)
    {
        StopExecLocal = flag;
    }

    public boolean getStopExecLocal()
    {
        return StopExecLocal;
    }
//20080418 [JLbVΉ end
    public void setSerachButtonObj( javax.swing.JButton firstbutton,
                                             javax.swing.JButton nextbutton, 
                                             javax.swing.JButton prevtbutton )
    {
        _firstbutton = firstbutton;
        _nextbutton  = nextbutton;
        _prevbutton = prevtbutton;
    }
    
    public void setSearchButtonEnable()
    {
        _firstbutton.setEnabled(true);
        _nextbutton.setEnabled(true);
        _prevbutton.setEnabled(true);
    }
    
    public void setSearchButtonDisable()
    {
        _firstbutton.setEnabled(false);
        _nextbutton.setEnabled(false);
        _prevbutton.setEnabled(false);
    }
    
    public void setIsExec(boolean exec)
    {
        IsExec = exec;
    }
    
    public boolean getIsExec()
    {
        return IsExec;
    }
    
//20080415 f@\ǉ start
    public void setInfoLabel(javax.swing.JLabel label)
    {
        this.infolabel = label;
    }
//20080415 f@\ǉ end
//20080416 f@\ǉ start
    public void setStopExec(boolean flag)
    {
//20080724 摜 start
        setStopExecMain(flag);
//20080724 摜 end
        if ( imginfo == null ) {
            return;
        }
        this.imginfo.setStopExec(flag);
        System.out.println("StopExecݒ肵܂B");
    }

    public boolean getStopExec()
    {
        if ( imginfo == null ) {
            return false;
        }
        return this.imginfo.getStopExec();
    }
//20080416 f@\ǉ end
    public int getDLImgDataSize()
    {
        return DLImgDataSie;
    }
    
    public void setDLImgDataSize(int size)
    {
        DLImgDataSie = size;
    }
    
    public int getDLImgHight()
    {
        return DLImgHight;
    }
    
    public void setDLImgHight(int size)
    {
        DLImgHight = size;
    }
    
    public int getDLImgWidth()
    {
        return DLImgWidth;
    }
    
    public void setDLImgWidth(int size)
    {
        DLImgWidth = size;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
    }
   
    public void putImgFile(ImgUrlInfo ImgFile)
    {
//20080419 [JLbVΉ start
        File LocalPath = ImgFile.getImgLocalPath();
        if( PreemptedFilePathSet.contains(LocalPath) == false) {
            PreemptedFilePathSet.add(LocalPath);
        } else {
            return;
        }
//20080419 [JLbVΉ end
        ImgFileList.add(ImgFile);
    }
    
    public ImgUrlInfo getImgFile(int i)
    {
        ImgUrlInfo imginfo;
//20080409 xԍ摜NOϊe[uo^Ή start
//        imginfo = (ImgUrlInfo) ImgFileList.get(i);
        try {
            imginfo = (ImgUrlInfo) ImgFileList.get(i);
        } catch (IndexOutOfBoundsException ex) { 
            imginfo = null;
        }
        if ( imginfo == null ) {
            return null;
        }
//20080409 xԍ摜NOϊe[uo^Ή end
        return imginfo;
    }
    
    public void delImgFile(int i)
    {
        ImgFileList.remove(i);
    }
    
    public int getImgFileListSize()
    {
        return ImgFileList.size();
    }
    
//20080914 TCgΉ start
//    public GoogleSearchExec GoogleSearchExecFirst(String keyword)
    public GoogleSearchExec GoogleSearchExecFirst(String keyword, String url)
//20080914 TCgΉ end
                    throws GepGoogleImgException, MalformedURLException, IOException, Exception
    {
        this._keyword = keyword;
        MakeKeywordDir(new File(GepGoogleImgViewer.rootdir));
        GoogleSearchExec searchmain = new GoogleSearchExec();
            
        searchmain.setKeyword(keyword);
//20080914 TCgΉ start
        searchmain.setSourceUrl(url);
//20080914 TCgΉ end

        if ( searchmain.GetResultPage() == false ) {
            throw new GepGoogleImgException("ʂ擾ł܂łB");
        }

        searchmain.setResultURLList();
        String[] urllist = searchmain.getResultURLList();

        return searchmain;
    }
    
//20080415 f@\ǉ start
//    public void ImgSearchExec( GoogleSearchExec result , 
//                            javax.swing.JLabel infolabel )
//                    throws GepGoogleImgException, MalformedURLException, IOException, Exception
//20080415 f@\ǉ start
    public void ImgSearchExec( GoogleSearchExec result )
                    throws GepGoogleImgException, MalformedURLException, IOException, Exception
    {
        
//20080724 摜 start
        int ResultPageCnt = result.getResultURLListCnt();
        _ResultPageCnt = ResultPageCnt;
        infolabel.setText("摜EEE");
        infolabel.repaint();
//20080829 擾0Iǉ start
        if ( ResultPageCnt == 0 ) {
            this.setIsExec(false);
            this.setSearchButtonEnable();
            infolabel.setText("ʂ0łB");
            infolabel.repaint();
            System.gc();
            return;
        }
//20080829 擾0Iǉ end
//20081011 zXgÂ݃EGCgɕύX start
        HashSet<String> serchHostList = new HashSet<String>();
//20081011 zXgÂ݃EGCgɕύX end
        for (int lpi=0 ; lpi < ResultPageCnt ; lpi++ ) {
            if ( IsExec == false ) {
                return;
            }
            String ImgSearchURL = result.getResultURLList(lpi);
//20080416 f@\ǉ start
//            GoogleSearchImgExec imginfo = new GoogleSearchImgExec(
            ImgSearchThreadSub ImgSearchSub = new ImgSearchThreadSub();
            ImgSearchSub.SearchExecImgInit( this, ImgSearchURL, infolabel);
//20080914 [ho[{Ή start
//20080914 EGCgԕύX start
//            ImgSearchThreadSub.sleep(1000);
//20081011 zXgÂ݃EGCgɕύX start
//            ImgSearchThreadSub.sleep(20000);
            
//20080914 EGCgԕύX end
//20080914 [ho[{Ή end
//20081206 R[lbg[NoRŌURLɃANZX{EGCgp~ start
//            String workSerchURL = new URL(ImgSearchURL).getHost();
            //ImgSearchURL = workSerchURL += "nyud.net";
//            String workSerchURL = new URL(ImgSearchURL).getHost();
//            if(serchHostList.contains(workSerchURL) == true) {
//                serchHostList.clear();
//                for( int i=0; i < 20 ; i++ ) {
//                    if( getStopExecMain() == true) {
//                        setIsExec(false);
//                        return;
//                    }
//                    ImgSearchThreadSub.sleep(1000);
//                }
//            }
//20081011 zXgÂ݃EGCgɕύX end
            
            ImgSearchSub.start();
//20081011 zXgÂ݃EGCgɕύX start
//            serchHostList.add(workSerchURL);
//20081206 R[lbg[NoRŌURLɃANZX{EGCgp~ end
//20081011 zXgÂ݃EGCgɕύX end
//            this.imginfo = new GoogleSearchImgExec(
//20080416 f@\ǉ end
//                   result.makeImgfullURL( ImgSearchURL ) );
//20080415 f@\ǉ start 
//            if ( imginfo.getStopExec() == true ) {
//                return;
//            }
//20080415 f@\ǉ end
/*
            if( imginfo.GetResultPage(infolabel) == false ) {
                continue;
            }
            infolabel.setText(result.makeImgfullURL( ImgSearchURL ) + "EEE");
            infolabel.repaint();
            
            int imgurlcnt = imginfo.getResultImgURLListCnt();
            for( int i=0 ; i < imgurlcnt ; i++ ) {
                if ( IsExec == false ) {
                    return;
                }
*/
//20080415 f@\ǉ start 
//                if ( imginfo.getStopExec() == true ) {
//                    return;
//                }
//20080415 f@\ǉ end
/*
                ImgUrlInfo img = imginfo.getResultImgURLList(i);
                File imgfile = this.DLImgFile(
                        result.getResultURLList(lpi), img.getImgUrlStr(), img.getImgExt(),
                        this.RootDir, infolabel );
                infolabel.setText(result.makeImgfullURL( ImgSearchURL ) + "EEE");
                infolabel.repaint();
                if ( imgfile != null ) {
                    ImgUrlInfo localimginfo = new ImgUrlInfo(ImgSearchURL, imgfile, 
                            new File(new File(imgfile.getParentFile().getParentFile(), "smb") ,"sm" + imgfile.getName() ) );
                    this.putImgFile(localimginfo);
                }
            }
            infolabel.setText("摜EEE");
            infolabel.repaint();
*/
        } 
//        infolabel.setText("_E[h܂B");
//        System.gc();
//20080724 摜 end
    }
    
    public File MakePageDirLv1(File baseDir, int page, String url, boolean isMain)
            throws GepGoogleImgException, IOException
    {
        String DirName = Integer.toString( page );
        File Dir = new File( baseDir, DirName );
        
        if ( Dir.exists() == false ) {
            if ( Dir.mkdir() == false ) {
                throw new GepGoogleImgException("MakePageDirLv1:fBNg" + Dir.getName() + "쐬ł܂łB");
            }
        }
        return this.MakePageDirLv2( Dir, url, isMain );
    }
    
    public File MakePageDirLv2(File BaseDir, String url , boolean isMain)
                throws GepGoogleImgException, IOException
    {
        MessageDigest digest = null;
        try {
            digest = MessageDigest.getInstance("MD5");
        } catch (NoSuchAlgorithmException ex) {
            ex.printStackTrace();
            return null;
        }
        String sDirName = this.toHexString ( digest.digest( url.getBytes() ) );
        System.out.println(sDirName);
        
        File siteDir = new File( BaseDir, sDirName);

        if ( siteDir.exists() == false ) {
            try {
                if ( siteDir.mkdir() == true ) {
                    File sitnamef = new File( siteDir, "sitename.txt" );
                    if ( sitnamef.exists() == false ) {
                        sitnamef.createNewFile();
                        FileOutputStream fout = new FileOutputStream( sitnamef );
                        OutputStreamWriter writer = new OutputStreamWriter( fout );
                        writer.write(url);
                        writer.flush();
                        writer.close();
                        fout.flush();
                        fout.close();
                    }
                }
            } catch (IOException ex) {
                throw new GepGoogleImgException("MakePageDirLv2:fBNg" + siteDir.getName() + "쐬ł܂łB");
            }
        }
        
        File gDir = null;
        
        if ( isMain == true ) {
            gDir = new File( siteDir, "main" ); 
        } else {
            gDir = new File( siteDir, "smb" ); 
        }
        
        if ( gDir.exists() == false ) {
            if ( gDir.mkdir() == false ) {
                throw new GepGoogleImgException("MakePageDirLv2:fBNg" + gDir.getName() + "쐬ł܂łB");
            }
        }
        
        return gDir;
   }
            
    public File MakeKeywordDir(File root)
                 throws GepGoogleImgException, IOException, Exception
    {
        String DirName;
        DirName = GepGoogleImgViewer.byteURLEncode(this._keyword);

        if ( root.exists() == false) {
            if ( root.mkdir() == false ) {
                throw new GepGoogleImgException("MakeKeywordDir:fBNg" + root.getName() + "쐬ł܂łB");
            }
        }
        
        this.RootDir = new File( root, DirName ); 
        
        if ( this.RootDir.exists() == false ) {
            try {
                if ( this.RootDir.mkdir() == true ) {
                    File wdnmfile = new File( this.RootDir, "keyword.txt" );
                    if ( wdnmfile.exists() == false ) {
                        wdnmfile.createNewFile();
                        FileOutputStream fout = new FileOutputStream( wdnmfile );
                        OutputStreamWriter writer = new OutputStreamWriter( fout );
                        writer.write(this._keyword);
                        writer.flush();
                        writer.close();
                        fout.flush();
                        fout.close();
                    }
                    return this.RootDir;
                }
            } catch (IOException ex) {
                throw new GepGoogleImgException("MakeKeywordDir:fBNg" + this.RootDir.getName() + "쐬ł܂łB");
            }
        }
        
        return this.RootDir;
    }
    
    private String toHexString(byte[] arr) {
        StringBuffer buff = new StringBuffer(arr.length * 2);
        for (int i = 0; i < arr.length; i++) {
            String b = Integer.toHexString(arr[i] & 0xff);
            if (b.length() == 1) {
                buff.append("0");
            }
            buff.append(b);
        }
        return buff.toString();
    }
    
    public static String byteURLEncode(String url)
                throws Exception
    {
        StringBuffer encbuf = new StringBuffer();
        byte[] bytebuf = url.getBytes();
        int length = bytebuf.length;
        for ( int i=0 ; i < length ; i++ ) {
            encbuf.append("%" + String.format("%1$02X", bytebuf[i]));
        }
        return encbuf.toString();
    }
    
    private File searchImgFile(File RootDir, String fname)
                    throws IOException
    {
//20080724 [JLbVfBNgC start
//        File[] DirList = RootDir.listFiles(new DirFileFilter());
        File[] DirList = RootDir.getParentFile().getParentFile().listFiles(new DirFileFilter());
        int dircnt = DirList.length;
        for( int i=0 ; i < dircnt ; i++ ) {
            File SearchDir = new File(DirList[i], this.filemdir);
//20080724 [JLbVfBNgC end
            File[] flist = SearchDir.listFiles();
            if ( flist == null ) {
                return null;
            }
            int filecnt = flist.length;
            for ( int lp=0 ; lp < filecnt ; lp++ ) {
                if ( flist[lp].getName().equals(fname) == true ) {
                    return flist[lp];
                }
            }
        }
        return null;
    }
    
    private File GetdlImgFileObj(String URL , URLConnection con , String ext , File dlDir )
                throws GepGoogleImgException, IOException
    {
        MessageDigest digest = null;
        try {
            digest = MessageDigest.getInstance("MD5");
        } catch (NoSuchAlgorithmException ex) {
            ex.printStackTrace();
            return null;
        }
        
        try {
            String DLFName = this.toHexString ( digest.digest( URL.getBytes() ) );
            digest.reset();
            
            DLFName += "." + ext;
            File DLFile = this.searchImgFile(dlDir, DLFName);
            if ( DLFile != null ) {               
//20080724 fobOp start
                    System.out.println("DLFile.lastModified() = " + DLFile.lastModified());
                    System.out.println("con.getLastModified() = " + con.getLastModified());
//20080724 fobOp end
                if( DLFile.lastModified() < con.getLastModified()) { 
                    DLFile.delete();
                    DLFile = new File(dlDir, DLFName);
                    DLFile.createNewFile();
                    return DLFile;
                }
//20080724 [JLbVfBNgC start
//                return null;
                return DLFile;
//20080724 [JLbVfBNgC end
            }
            DLFile = new File(dlDir, DLFName);
            DLFile.createNewFile();
//20080724 [JLbVfBNgC start
            DLFile.setLastModified(0);
//20080724 [JLbVfBNgC start
            return DLFile;
        } catch (IOException ex) {
            throw new GepGoogleImgException("dlImgFile:C[WLbV̌ɃG[܂B");
        }
     }
    
    public File DLImgFile(String SiteURL, String ImgURL, String ext, File RootDir,
                            javax.swing.JLabel infolabel )
                throws GepGoogleImgException, IOException, MalformedURLException, InterruptedException
    {
        int readsize = 0;
//20080724 摜 start
//        byte[] buf = this.ImgdataBuf;
        byte[] buf = new byte[4096];
//20080724 摜 end
        try {
            if ( RootDir.exists() == false ) {
                if ( RootDir.mkdir() == false ) {
                    infolabel.setText("摜t@CۑpfBNg쐬ł܂B");
                    infolabel.repaint();
                    throw new GepGoogleImgException( "摜t@CۑpfBNg쐬ł܂B" );
                }
            }
            File DLFile;
//20080412 vLVڑΉ start
//            URL ImgURLObj = new URL(ImgURL);
            URL ImgURLObj = searchmain.getCompatibleURL(ImgURL);
//20080412 vLVڑΉ end
//20080411 摜do^h~ start
            if( PreemptedURLSet.contains(ImgURLObj) == false ) {
                PreemptedURLSet.add(ImgURLObj);
            } else {
                return null;
            }
//20080411 摜do^h~ end
            ImageIcon Imginfo = new ImageIcon( ImgURLObj );
            
            infolabel.setText(ImgURL + "_E[hΏۂ`FbNEEE");
            if ( ( this.getDLImgHight() > 0 ) && 
                   ( Imginfo.getIconHeight() < this.getDLImgHight() ) ) {
                infolabel.setText("摜̍wTCYłB");
                infolabel.repaint();
                return null;
            }
            
            if ( ( this.getDLImgWidth() > 0 ) &&
                    ( Imginfo.getIconWidth() < this.getDLImgWidth() ) ) {
                infolabel.setText("摜̕wTCYłB");
                infolabel.repaint();
                return null;
            }
            File dlDir = MakePageDirLv2(RootDir, SiteURL , true);
            
            if ( dlDir == null ) {
                infolabel.setText("ۑpfBNg쐬ł܂łB");
                infolabel.repaint();
                return null;
            }
            HttpURLConnection con = (HttpURLConnection)ImgURLObj.openConnection();
            con.setRequestProperty("Referer", SiteURL );
            DLFile = GetdlImgFileObj(ImgURL, con, ext, dlDir );

            if ( DLFile == null) {
                infolabel.setText("");
                infolabel.repaint();
                return null;
            }
//20080724  [JLbVfBNgC start
            if ( ( DLFile.lastModified() < con.getLastModified() == false ) ) {
                con.disconnect();
                return DLFile;
            } 
//20080724  [JLbVfBNgC end
            System.out.println(con.getLastModified());
            if ( DLFile.setLastModified(con.getLastModified()) == false ) {
                System.out.println("t@C̃^CX^v߂܂łB");
            }
            InputStream in = con.getInputStream();
            FileOutputStream fout = new FileOutputStream(DLFile);
                    
            infolabel.setText(ImgURL + "_E[hEEE");
            infolabel.repaint();
            while( ( readsize = (in.read(buf))) != -1 ) {
//20080724 fobOpR[h start
                System.out.println("摜t@C݃TCY : " + readsize + "Byte");
//20080724 fobOpR[h end
                fout.write(buf, 0, readsize);
            }
            
            fout.flush();
            fout.close();
            
            in.close();
            
            if ( ( this.getDLImgDataSize() > 0 ) &&
                    ( DLFile.length() < this.getDLImgDataSize() ) ) {
                infolabel.setText("");
                infolabel.repaint();
                return null;
            }
            con.disconnect();
            GenThumbnail(DLFile, ext);
                
            infolabel.setText("");
            infolabel.repaint();
            return DLFile;
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (MalformedURLException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (GepGoogleImgException ex) {
            throw ex;
        } finally {
            infolabel.setText("");
            infolabel.repaint();
        }
        return null;
    }    
    
    public File GenThumbnail( File src , String ext)
                    throws IOException, InterruptedException
    {
        BufferedImage image = ImageIO.read(src);
        double height = 0;
        double width  = 0;
        double rate = 0;
        boolean noresizeflg = false;
//20080408 TlC̃TCY菬摜Ή start
        if ( image.getHeight() <= this.ThumbHight) {
           if ( image.getWidth()  <= this.ThumbWidth) {
               noresizeflg = true;
           } else {
                width  = this.ThumbWidth;
                double tmpheight = this.ThumbHight / image.getHeight();
                if ( tmpheight < 1) {
                    tmpheight = 1;
                }
                height = image.getWidth() * tmpheight;
                rate = width / image.getWidth();
           }
        } else if ( image.getWidth() <= this.ThumbWidth) {
           if ( image.getHeight()  <= this.ThumbHight) {
               noresizeflg = true;
           } else {
                height = this.ThumbHight;
                double tmpwidth = this.ThumbWidth / image.getWidth();
                if ( tmpwidth < 1) {
                    tmpwidth = 1;
                }
                width = image.getHeight() * tmpwidth;
                rate = height / image.getHeight();
           }
        } else if ( ( image.getHeight() / ( image.getWidth() / this.ThumbWidth ) ) > this.ThumbHight ) {
//        if ( ( image.getHeight() / ( image.getWidth() / this.ThumbWidth ) ) > this.ThumbHight ) {
//20080408 TlC̃TCY菬摜Ή end
            height = this.ThumbHight;
            width =  (image.getWidth() * ( height / image.getHeight() ));
            rate = height / image.getHeight();
        } else {
            width  = this.ThumbWidth;
            height = (image.getHeight() * ( width / image.getWidth() ));
            rate = width / image.getWidth();
        }
        BufferedImage shrinkImage;
        int imagetype = image.getType();
//20080408 TlC̃TCY菬摜Ή start
        if ( noresizeflg == true ) {
            shrinkImage = image;
        } else if ( imagetype == BufferedImage.TYPE_CUSTOM ) { 
//        if ( imagetype == BufferedImage.TYPE_CUSTOM ) { 
//20080408 TlC̃TCY菬摜Ή end
            ImageFilter filter = new AreaAveragingScaleFilter((int)width, (int)height);
            ImageProducer im = new FilteredImageSource(image.getSource(), filter);
            Image newImage = Toolkit.getDefaultToolkit().createImage(im);

            MediaTracker tracker = new MediaTracker(new Component(){});
            tracker.addImage(newImage, 0);
            tracker.waitForAll();

            PixelGrabber pixelGrabber = new PixelGrabber(newImage, 0, 0, -1, -1, false);
            pixelGrabber.grabPixels();
            ColorModel cm = pixelGrabber.getColorModel();

            final int w = pixelGrabber.getWidth();
            final int h = pixelGrabber.getHeight();
            WritableRaster raster = cm.createCompatibleWritableRaster( w, h );

            shrinkImage = 
            new BufferedImage(
                                cm, 
                                raster, 
                                cm.isAlphaPremultiplied(), 
                                new Hashtable());
                                shrinkImage.getRaster().setDataElements(0, 0, w, h, pixelGrabber.getPixels()
                            );
        } else {
            shrinkImage = new BufferedImage(
                (int)width,
                (int)height,
                imagetype);
            AffineTransformOp atOp =
            new AffineTransformOp(AffineTransform.getScaleInstance( rate , rate ), null);

            atOp.filter(image, shrinkImage);
        }
        File ThumbDir = new File(src.getParentFile().getParentFile() , "smb" );
        if ( ThumbDir.exists() == false) {
            ThumbDir.mkdir();
        }
        File ThumbFile = new File(ThumbDir, ("sm" + src.getName() ) );
        ThumbFile.createNewFile();
        
        FileOutputStream fout = new FileOutputStream( ThumbFile );
        
        if( extcnvhashsm.get(ext) != null ) {
            ext = (String)extcnvhashsm.get(ext);
        }
        
        ImageIO.write(shrinkImage, ext, fout);
        
        fout.flush();
        fout.close();
        
        return ThumbFile;
    }
//20080418 [JLbVΉ start    
    public void SearchLocalImgFile(File root)
    {
        File[] siteDirList = root.listFiles(new DirFileFilter());
        int sitedircnt;
        try {
            sitedircnt = siteDirList.length;
        } catch (NullPointerException ex){
            infolabel.setText("C[W܂łB");
            infolabel.repaint();
            return;
        }
        infolabel.setText("[J̃C[WEEE");
        infolabel.repaint();
        for ( int i=0 ; i < sitedircnt ; i++ ) {
            if ( StopExecLocal == true ) {
                infolabel.setText("𒆎~܂B");
                infolabel.repaint();
                return;
            }
            File sitenamef = new File(siteDirList[i], "sitename.txt");
            if ( ( sitenamef.exists() == false ) || (sitenamef.canRead() == false ) ) {
                continue;
            }
            FileReader frd = null;
            BufferedReader rd = null;
            try {
                frd = new FileReader(sitenamef);
                rd = new BufferedReader(frd);
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
                continue;
            }
             String siteurl = "";
            try {
                siteurl = rd.readLine();
            } catch (IOException ex) {
                ex.printStackTrace();
                continue;
            }
            if ( siteurl == ""  ) {
                System.out.println("TCgURLt@Cɂ܂B");
                continue;
            }
            File[] ImgFileList = new File(siteDirList[i],"main").listFiles();
            int ImgfCnt = ImgFileList.length;
            for ( int cnt=0 ; cnt < ImgfCnt ; cnt++ ) {
                if ( StopExecLocal == true ) {
                    infolabel.setText("𒆎~܂B");
                    infolabel.repaint();
                    return;
                }
                File smbFile = new File( new File(siteDirList[i], "smb"), "sm" + ImgFileList[cnt].getName() );
                if ( ( smbFile.exists() == false ) || ( smbFile.canRead() == false ) ) {
                    continue;
                }
                ImgUrlInfo localimginfo = new ImgUrlInfo( siteurl , ImgFileList[cnt] , smbFile);
                this.putImgFile(localimginfo);
            }
            this._form.repaint();
            this._form.update(this._form.getGraphics());
            this._form.paintComponents(this._form.getGraphics());
        }
    }
    //20080418 [JLbVΉ end
}
