/*
 * GoogleSearchExec.java
 *
 * Created on 2008/02/06, 21:23
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.ArrayList;
import java.util.regex.*;

/**
 *
 * @author jinpu
 */
public class GoogleSearchExec {
    private static final String googleurl       = "http://www.google.co.jp/search";
    private static final String googleurlq_st   = "q=";
//20080914 TCgΉ start
    private static final String googleurlq_site = "&as_sitesearch=";
//20080914 TCgΉ end
    private static final String googleurlq_end  = "&lr=lang_ja&ie=shift-jis&oe=shift-jis&aq=t&safe=off&start=" ;
    private static final String ERR_LABEL       = "[ERR]";
    private static final String DEF_ERR_MSG_NOTCONNECT  = ERR_LABEL + "Not Connected";
    private static final String DEF_HTTP_STATUS_OK      = "200";
//20080914 TCgΉ start
//    private static final String DEF_HIT_REGEXP_STR             = "Ɉv.*<b>([0-9,]+)</b>\\s*";
    private static final String DEF_HIT_REGEXP_STR             = "<b>([0-9,]+)</b>\\s*";
//20080914 TCgΉ end
    public  static final int    DEF_GOOGOLE_RESULT_MAX = 1000;
    
    protected         URL             Url;
    protected         HttpURLConnection Urlcon;
    private           String          Keyword;
    private           String          KeywordOrg;
    protected         String          SearchURLStr;
    protected         String[]        ResultURLList;
    protected         int            ResultURLListCnt;      
    private           String          Linkregex;
    private           String          PagecntRegex;
    
    protected         String          ContentBody;
    protected         byte[]         Contentbuf;
    protected         ByteArrayOutputStream Bodyoutbufstm;
    
    private           int            PageNo;
    private           int            Pagecnt;
    protected         int            Resultcnt;
    protected         String          HostName;
    protected         String          Path;
    protected         String          Portstr;
//20080412 vLVڑΉ start
    private           String          proxyHost;
    private           int             proxyPort;
//20080412 vLVڑΉ end
//20080914 TCgΉ start
    private           String          SourceUrlOrg;
    private           String          SourceUrl;
//20080914 TCgΉ end
//20081206 R[lbg[NoRŌURLɃANZX{EGCgp~ start
    Pattern hostptn;
//20081206 R[lbg[NoRŌURLɃANZX{EGCgp~ end
//20081213 URLhtml^OĂꍇɍ폜 start
    Pattern deltagptn;
//20081213 URLhtml^OĂꍇɍ폜 end
   /** Creates a new instance of GoogleSearchExec */
    public GoogleSearchExec()
    {
        Url             = null;
        Urlcon          = null;
        Keyword         = new String();
        SearchURLStr    = new String();
        ResultURLList   = null;
        ResultURLListCnt = 0;
        Contentbuf      = new byte[1024];
        Bodyoutbufstm   = new ByteArrayOutputStream();
        ContentBody     = "";
        PageNo          = 0;
        Pagecnt         = 0;
        Resultcnt       = 0;
        setLinkregex();
        setPagecntRegex();
//20080914 TCgΉ start
        SourceUrl       = new String();
//20080914 TCgΉ end
//20080412 vLVڑΉ start
        File proxyfile = new File("proxyinfo.txt");
        
        if( ( proxyfile.exists() == true) && (proxyfile.canRead() == true ) ) {
            try {
                FileReader in = new FileReader(proxyfile);
                BufferedReader buf = new BufferedReader(in);
                this.proxyHost = buf.readLine();
                String port = buf.readLine();
                this.proxyPort = Integer.parseInt(port);
                System.out.println("vLVڑ[h");
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        } 
//20080412 vLVڑΉ end
    }
    
//20080412 vLVڑΉ start
    public URL getCompatibleURL(String urlstr)
                throws MalformedURLException
    {
        if ( proxyHost != null ) {
//20081206 R[lbg[NoRŌURLɃANZX{EGCgp~ start
            proxyHost += ".nyud.net";
//20081206 R[lbg[NoRŌURLɃANZX{EGCgp~ end
            return new URL("http", proxyHost, proxyPort, urlstr);
        } 
        
//20081206 R[lbg[NoRŌURLɃANZX{EGCgp~ start
//        return new URL(urlstr);
        if(hostptn == null)
        {
            hostptn = Pattern.compile("(^http://[^/]+)");
        }
        Matcher hostmath = hostptn.matcher(urlstr);
        hostmath.find();
        return new URL(hostmath.replaceFirst(hostmath.group(1) + ".nyud.net"));
//20081206 R[lbg[NoRŌURLɃANZX{EGCgp~ end
    }
//20080412 vLVڑΉ end
    public void Connect()
                throws GepGoogleImgException, MalformedURLException
    {
        try {
//20080412 vLVڑΉ start
//            Url = new URL(SearchURLStr);
              Url = this.getCompatibleURL(SearchURLStr);
              System.out.println(Url.toString());
//20080412 vLVڑΉ end
        } catch (MalformedURLException ex) {
            throw ex;
        }
        try {
           Urlcon = (HttpURLConnection)Url.openConnection();
           Urlcon.setRequestProperty("User-Agent", 
                    "Mozilla/5.0 (Windows; U; Windows NT 5.1; ja; rv:1.8.0.3) Gecko/20060426 Firefox/1.5.0.3");
            Urlcon.setRequestProperty( "Referer", SearchURLStr );
            Urlcon.connect();
           if ( Urlcon.getRequestProperty("Transfer-Encoding") == "chunked" ) {
               Urlcon.disconnect();
               Urlcon.setRequestProperty("Transfer-Encoding" , "chunked");
               Urlcon.connect();
               
           }
        } catch (Exception e) {
            throw new GepGoogleImgException("Connect:ڑ:" + SearchURLStr + "ւ̐ڑɎs܂B");
        }
        
        return ;
    }
//20080914 TCgΉ start
    public void setSourceUrl(String url)
                throws GepGoogleImgException, Exception
    {
        SourceUrlOrg = url;
        SourceUrl = GepGoogleImgViewer.byteURLEncode(SourceUrlOrg);
    }

    public String getSorceUrlOrg()
    {
        return SourceUrlOrg;
    }
//20080914 TCgΉ end

    public void setKeyword(String keyword)
                throws GepGoogleImgException, Exception
    {
        KeywordOrg = keyword;
        String sjiskeywd = new String(keyword.getBytes(), "Shift-Jis");
        Keyword = GepGoogleImgViewer.byteURLEncode(keyword);
    }
    
    public String getKeywordOrg()
    {
        return KeywordOrg;
    }
    
    public String getStatusHeader()
                throws GepGoogleImgException
    {

        if(Urlcon == null) {
            throw new GepGoogleImgException("getStatusHeader:RlNVIuWFNgNULLłB");
        }
        
        return Urlcon.getHeaderField(0);
    }
    
    public boolean isHttpFound()
                throws GepGoogleImgException, IOException, Exception
    {
        String Status = this.getStatusHeader();
        
        if ( Status == null ) {
            return false;
        }
        
        if ( Status.equals("HTTP/1.1 200 OK") == true ) {
            return true;
        }
        
        if ( Status.equals("HTTP/1.0 200 OK") == true ) {
            return true;
        }
        
        return false;
    }
    
    public void setSearchURLStr()
                 throws GepGoogleImgException
   {
        try {
            SearchURLStr = this.googleurl + "?" +
                   this.googleurlq_st + Keyword + 
//20080914 TCgΉ start
                   this.googleurlq_site + SourceUrl + 
//20080914 TCgΉ end
                   this.googleurlq_end + Integer.toString(this.PageNo * 10);
            System.out.println(SearchURLStr);
            URL wkUrl = null;
            try {
//20080412 vLVڑΉ start
//              wkUrl = new URL(SearchURLStr);
              wkUrl = this.getCompatibleURL(SearchURLStr);
//20080412 vLVڑΉ end
            } catch (MalformedURLException ex) {
                throw ex;
            }
            this.HostName     = wkUrl.getHost();
            this.Path         = wkUrl.getPath();
            int  port         = wkUrl.getPort();
            
            if ( port != ( -1 ) ) {
                this.Portstr  = ":" + Integer.toString(port);
            } else {
                this.Portstr  = "";
            }
            this.Path = this.Path.substring( 0, this.Path.lastIndexOf( "/" ) + 1 );

        } catch (Exception e) {
            throw new GepGoogleImgException("setSearchURLStr:G[܂B");
        }
    }

    public String getContentBody()
    {
        return ContentBody;
    }
    
    protected  void setContentBody()
                throws GepGoogleImgException, IOException, Exception
    {
        InputStream in = Urlcon.getInputStream();
        ContentBody = this.getStrFromBytebuf(in);
        in.close();
        Urlcon.disconnect();
    }
    
    private String getLinkregex()
    {
        return Linkregex;
    }
    
    private void setLinkregex()
    {
//20080829 googleʕ\tH[}bgύXΉ start
//        Linkregex = "<h2 class=r>[^<]*<a href=\"([^\"]+)\"";
        Linkregex = "<h3 class=r>[^<]*<a href=\"([^\"]+)\"";
//20080829 googleʕ\tH[}bgύXΉ end
    }
    
    public String[] getResultURLList()
    {
        return ResultURLList;
    }
    
    public String getResultURLList(int index)
    {
        return ResultURLList[index];
    }
    
    public void setResultURLList()
                throws IOException, GepGoogleImgException
    {
        ArrayList urllist = new ArrayList();
        String regex = getLinkregex();
        
        Pattern ptn = Pattern.compile(regex);
        Matcher matchinfo = ptn.matcher(ContentBody);
        
        matchinfo.reset();
        
        while(matchinfo.find()) {
            urllist.add(matchinfo.group(1));
        }
        matchinfo.reset();
        int linkcnt = urllist.size();
        ResultURLList = new String[linkcnt];
        setResultURLListCnt(linkcnt);
        
        for(int i=0 ; i < linkcnt ; i++) {
            ResultURLList[i] = (String)urllist.get(i);
        }
    }
    
    public int getResultcnt()
    {
        return Resultcnt;
    }
    
    private String getPagecntRegex()
    {
        return PagecntRegex;
    }
    
    public void setPagecntRegex()
    {
        PagecntRegex = DEF_HIT_REGEXP_STR;
    }
    
    public int getPagecnt()
    {
        return Pagecnt;
    }
    
    public void setPagecnt()
                throws Exception
    {
        String regex = new String( getPagecntRegex().getBytes(), "Shift-Jis" );
    
        Pattern ptn = Pattern.compile(regex);
        Matcher matchinfo = ptn.matcher(ContentBody);
    
        matchinfo.reset();
        if(matchinfo.find()) {
            System.out.print("matchinfo.group(1) = ");
            System.out.println(matchinfo.group(1));
            String Resultcntstr = matchinfo.group(1).replaceAll("," , "");
            Resultcnt = Integer.parseInt(Resultcntstr);
            if ( Resultcnt >= 10) {
                Pagecnt = Resultcnt / 10;
            } else {
                Pagecnt = 1;
            }
        } else {
            System.out.println("Pagecnt Regex Not Match!!");
        }
        matchinfo.reset();
}
    public int getNowPage()
    {
        return PageNo;
    }
    
    public void setPageNo(int no)
    {
        if(no > 1) {
            PageNo = no - 1;
        }
    }
    
    public int getResultURLListCnt()
    {
        return ResultURLListCnt;
    }
    
    public void setResultURLListCnt(int cnt)
    {
        ResultURLListCnt = cnt;
    }

    public boolean GetResultPage()
                throws GepGoogleImgException, MalformedURLException, IOException, Exception
    {
        this.setSearchURLStr();
        this.Connect();
        
        String Status = this.getStatusHeader();
        if ( this.isHttpFound() == false ) {
            System.out.println(Status);
            return false;
        }
        InputStream in;
        try {
            in = Urlcon.getInputStream();
        } catch (IOException ex) {
            System.out.println(this.Url.toString() + "擾ł܂łB");
            return false;
        }
        
        this.setContentBody();
        String body = this.getContentBody();
        this.setPagecnt();
        this.setResultURLList();
        String[] urllist = this.getResultURLList();
        int urlcnt = this.getResultURLListCnt();
            
        in.close();
        Urlcon.disconnect();
        System.out.println("googleʎ擾");
        return true;
    }
    
    public boolean GetNextPage()
                throws GepGoogleImgException, Exception
     {
        if ( this.PageNo >= ( this.Pagecnt - 1 ) ) {
            System.err.println("PageNo: Over fllow!! PageNo=" + this.PageNo);
            return false;
        }
        if ( this.PageNo >= ( GoogleSearchExec.DEF_GOOGOLE_RESULT_MAX / 10 ) ) {
            throw new GepGoogleImgException("googleł1000ȏ̌ʂ͎擾ł܂B");
        }
        this.PageNo++;
        
        return this.GetResultPage();
    }
    
    public boolean GetPrevPage()
                throws GepGoogleImgException, Exception
    {
        if ( this.PageNo <= 0 ) {
           System.err.println("PageNo: Over fllow!! PageNo=" + this.PageNo);
           return false;
        }
        this.PageNo--;

        return this.GetResultPage();
    }
    
    public String getStrFromBytebuf(InputStream in)
                throws IOException
   {
        Bodyoutbufstm.reset();
        int readsize = 0;
        
        while( ( readsize = (in.read(Contentbuf))) != -1 ){
            Bodyoutbufstm.write(Contentbuf, 0, readsize);
            System.out.println("RecbodyR[hϊEEE readsize = " + readsize);
        }
            
        String strValue = new String(Bodyoutbufstm.toByteArray(), "Shift-Jis");
        Bodyoutbufstm.reset();
        return strValue;
    }
    
    protected String makeImgfullURL(String URL)
    {
//20081214 URLhtml^OĂꍇɍ폜 start
        deltagptn = Pattern.compile("<[^>]*>");
        Matcher deltagmatch = deltagptn.matcher(URL);
        URL = deltagmatch.replaceAll("");
//20081214 URLhtml^OĂꍇɍ폜 end
       Pattern ptn = Pattern.compile("^http://.*");
       Matcher matchinfo = ptn.matcher( URL );
       
       if ( matchinfo.matches() ) {
           return URL;
       }
       matchinfo.reset();
       URI uri;
       try {
           uri = new URI("http://" + this.HostName + this.Portstr + this.Path + URL);
       } catch (URISyntaxException ex) {
           ex.printStackTrace();
           return null;
       }
       
       return uri.toString(); 
    }
}
